#ifndef _register_modules_h_
#define _register_modules_h_

#include "module.h"

#include "approximate_repeats_allison/approximate_repeats_allison.h"
#include "correlation/correlation.h"
#include "entropy/entropy.h"
#include "frequency_distribution/frequency_distribution.h"


namespace papi 
{
	/// List of registered modules
	Module* list_modules_all[] = 
	{
		new FrequencyDistribution("FrequencyDistribution"),
		new Correlation("Correlation"),
		new Entropy("Entropy"),
		new ApproximateRepeats("ApproximateRepeats")
	};
}

#endif

